DECLARE SUB showmessage (message$)
DECLARE SUB addtextdialogue (t$)
DECLARE SUB searchlevelforitem ()
DECLARE SUB eraselevelitems ()
DECLARE SUB eraselevelsprites ()
DECLARE SUB addlevelitem ()
DECLARE SUB showposition ()
DECLARE SUB showdialogue (filename$)
DECLARE SUB addbox (px1%, py1%, px2%, py2%)
DECLARE SUB clearstatussprites ()
DECLARE SUB addstatussprite (x%, y%, frame%, imxnumber%)
DECLARE SUB loaddefaultimx ()
DECLARE FUNCTION mergeloadimx% (filename$, imxbank%)
DECLARE SUB checktalknpc ()
DECLARE SUB docontrols ()
DECLARE SUB collidenpc ()
DECLARE SUB clearnpcs ()
DECLARE SUB collidelevel (px%, py%, poldx%, poldy%, pflag%)
DECLARE SUB fadeouttransition ()
DECLARE SUB initrandomness ()
DECLARE FUNCTION getanimoffset% (f%)
DECLARE SUB walkingcontrol (f%, c%, D%)
DECLARE SUB donpc ()
DECLARE SUB loadassembly ()
DECLARE SUB initplayer ()
DECLARE SUB loadnewlevel (filename$)
DECLARE SUB inittilelookup ()
DECLARE SUB initcolourtables ()
DECLARE SUB initviewports ()
DECLARE SUB initsprites ()
DECLARE SUB playgame ()
DECLARE SUB addnpc ()
DECLARE SUB addsprite (x%, y%, z%, frame%, imxnumber%, colourtable%, flags%, silhouette%)
DECLARE SUB errorexit (pstring$)
DECLARE SUB addviewport (px1%, py1%, px2%, py2%)
DECLARE SUB animtiles ()
DECLARE SUB docamera ()
DECLARE SUB minlimit (a%, b%)
DECLARE SUB maxlimit (a%, b%)
DECLARE SUB dofadeinout ()
DECLARE SUB loadstuff ()
DECLARE SUB doplayer ()
DECLARE SUB dotriggers ()
DECLARE SUB setlevelelement (x%, y%, value%)
DECLARE SUB teleport (filename$, x%, y%, linkflag%, index%)
DECLARE SUB drawscreen ()
DECLARE SUB initmaskenable ()
DECLARE SUB loadatrmap ()
DECLARE SUB loadimx ()
DECLARE SUB loadlevel ()
DECLARE SUB loadmasks ()
DECLARE SUB clearimxmem ()
DECLARE SUB loadpalette ()
DECLARE SUB loadtiles ()
DECLARE FUNCTION num$ (p%)
DECLARE SUB offkb ()
DECLARE SUB onkb ()
DECLARE SUB updatespritestruct ()
DECLARE SUB saveold ()
DECLARE SUB memfill (psegment&, poffset&, pvalue%, plength&)
DECLARE SUB memcopy (psourcesegment&, psourceoffset&, pdestinationsegment&, pdestinationoffset&, plength&)
'
'The rpg alpha .04
'
'By: _Gamerx (a.k.a. Ryan Ross)
'    Gradius (a.k.a. Milo Sedlacek)  email: sedlacek@execulink.com
'
CLS
SCREEN 13

'Define files
CONST MAXIMXFILES = 8
DIM SHARED levfile1$, chrfile1$, palfile1$
DIM SHARED asmfile1$, asmfile2$, asmfile3$, asmfile4$, asmfile5$
DIM SHARED mskfile1$, atrfile1$, inffile1$, defaultimxfile$
DIM SHARED fontimxfile$, borderimxfile$
DIM SHARED imxfile$(MAXIMXFILES)
inffile1$ = "town1.inf"
asmfile1$ = "rpengine.rtn"
asmfile2$ = "keyb2.rtn"
asmfile3$ = "chekmask.rtn"
asmfile4$ = "memfill.rtn"
asmfile5$ = "movemem.rtn"
defaultimxfile$ = "fabian.imx"
fontimxfile$ = "talktext.imx"
borderimxfile$ = "talkbox.imx"

'Define constants
'Maximum constants
CONST MAXLEVELITEMS = 20
CONST MAXSTATICSPRITES = 100
CONST MAXLEVELSPRITES = 500
CONST MAXSTATUSSPRITES = 200
CONST MAXVIEWPORTS = 9
CONST MAXTRIGGERS = 50
CONST MAXNPCS = 20

'Memory constants
CONST IMXBANK0WORDSIZE = 4000
CONST IMXBANK1WORDSIZE = 4000
CONST IMXBANK2WORDSIZE = 100
CONST IMXBANK3WORDSIZE = 100
CONST IMXBANK4WORDSIZE = 100
CONST IMXBANK5WORDSIZE = 100
CONST IMXBANK6WORDSIZE = 4500
CONST IMXBANK7WORDSIZE = 10000

'animation constants
CONST PLAYERWALKANIMDELAY = 2
CONST WATERANIMDELAY = 10

'spacing constants
CONST PLAYERYSPACING = 3
CONST PLAYERXSPACING = 6
CONST NPCSPACINGX = 3
CONST NPCSPACINGY = 6

'Radius constants
CONST NPCTALKRADIUSSQUARED = 300

'Location constants
CONST DIALOGUEBOXX = 64
CONST DIALOGUEBOXY = 30

'Viewport data structure (engine)
TYPE viewporttype
  x1 AS INTEGER
  y1 AS INTEGER
  x2 AS INTEGER
  y2 AS INTEGER
  statussegment AS INTEGER
  statusoffset AS INTEGER
  totalstatus AS INTEGER
  camerax AS INTEGER
  cameray AS INTEGER
END TYPE

'Sprite data structure (engine)
TYPE spritetype
  x AS INTEGER
  y AS INTEGER
  z AS INTEGER
  frame AS INTEGER
  imxnumber AS INTEGER        '(0-15)
  colourtable AS INTEGER
  flags AS INTEGER            'bit 0 = invisible, bit 1 = flipx, bit 2 = silhouette
  silhouette AS INTEGER       'silhouette colour
END TYPE

'Player's data structure
TYPE playertype
  x AS INTEGER
  y AS INTEGER
  z AS INTEGER
  tilex AS INTEGER
  tiley AS INTEGER
  flip AS INTEGER
  frame AS INTEGER
  direction AS INTEGER            '0 = up, 1 = right, 2 = down, 3 = left
  walkframe AS INTEGER
  walkanimcountdown AS INTEGER
  oldx AS INTEGER
  oldy AS INTEGER
END TYPE

'Triggers data structure
TYPE triggertype
  id AS INTEGER
  int0 AS INTEGER
  int1 AS INTEGER
  int2 AS INTEGER
  int3 AS INTEGER
  int4 AS INTEGER
  string0 AS STRING * 80
END TYPE

'Non player characters data structure
TYPE npctype
  id AS INTEGER
  x AS INTEGER
  y AS INTEGER
  z AS INTEGER
  flip AS INTEGER
  frame AS INTEGER
  imxnumber AS INTEGER
  direction AS INTEGER            '0 = up, 1 = right, 2 = down, 3 = left
  walkframe AS INTEGER
  walkanimcountdown AS INTEGER
  oldx AS INTEGER
  oldy AS INTEGER
  startwalkframe AS INTEGER
  motionchangecountdown AS INTEGER
  txtfile AS STRING * 40
  spritenumber AS INTEGER
END TYPE

'Items data structure
TYPE levelitemtype
  id AS INTEGER
  x AS INTEGER
  y AS INTEGER
  amount AS INTEGER
END TYPE

'Define globals
'engine variables
DIM SHARED engine%(8192)
DIM SHARED pal%(512)
DIM SHARED tiles%(32766)
DIM SHARED level%(6128), levelxsize%, levelysize%
DIM SHARED tilelookup%(256)
DIM SHARED viewport(MAXVIEWPORTS) AS viewporttype
DIM SHARED totalviewports%
DIM SHARED levelsprite(MAXLEVELSPRITES) AS spritetype, totallevelsprites%
DIM SHARED maskenable%(256)
DIM SHARED statussprites0(MAXSTATUSSPRITES) AS spritetype, totalstatussprites0%
DIM SHARED statussprites1(0) AS spritetype, totalstatussprites1%
DIM SHARED statussprites2(0) AS spritetype, totalstatussprites2%
DIM SHARED statussprites3(0) AS spritetype, totalstatussprites3%
DIM SHARED statussprites4(0) AS spritetype, totalstatussprites4%
DIM SHARED statussprites5(0) AS spritetype, totalstatussprites5%
DIM SHARED statussprites6(0) AS spritetype, totalstatussprites6%
DIM SHARED statussprites7(0) AS spritetype, totalstatussprites7%
DIM SHARED statussprites8(0) AS spritetype, totalstatussprites8%
DIM SHARED colourtable0%(256)
DIM SHARED colourtable1%(256)
DIM SHARED colourtable2%(256)
DIM SHARED spritestream(MAXLEVELSPRITES) AS spritetype
DIM SHARED doublebuffer%(2560)
DIM SHARED imx0%(IMXBANK0WORDSIZE)
DIM SHARED imx1%(IMXBANK1WORDSIZE)
DIM SHARED imx2%(IMXBANK2WORDSIZE)
DIM SHARED imx3%(IMXBANK3WORDSIZE)
DIM SHARED imx4%(IMXBANK4WORDSIZE)
DIM SHARED imx5%(IMXBANK5WORDSIZE)
DIM SHARED imx6%(IMXBANK6WORDSIZE)            'talking box imx bank
DIM SHARED imx7%(IMXBANK7WORDSIZE)            'npc's imx bank
'end -> engine variables

'System variables
DIM SHARED kbcontrol%(128), keyboardonflag%
DIM SHARED kb(128) AS INTEGER
DIM SHARED camerax%, cameray%
DIM SHARED checkmaskrtn%(64)
DIM SHARED atrmap%(1500)
DIM SHARED char AS STRING * 1
DIM SHARED block AS STRING * 256
DIM SHARED memfillrtn%(128), movememrtn%(256)
'end -> System variables

'Game variables
DIM SHARED player AS playertype

'Triggers
DIM SHARED trigger(MAXTRIGGERS) AS triggertype, totaltriggers%

'Npcs
DIM SHARED npc(MAXNPCS) AS npctype, totalnpcs%

'Old / New variables
DIM SHARED currentinffilename$
DIM SHARED newnpc AS npctype, preservenewnpc%

'Animation variables
DIM SHARED wateranimcountdown%, wateranimframe%

'Mode variables
DIM SHARED gamemode%    '0 = normal, 1 = fade out, 2 = fade in

'New variables
DIM SHARED newlevelxsize%, newlevelysize%
DIM SHARED newplayerx%, newplayery%

'List variables
DIM SHARED npcimxfile$(MAXNPCS), npcimxstartframe%(MAXNPCS), totalnpcimxfiles%

'Control variables
DIM SHARED spacebar%, oldspacebar%

'Frame variables
DIM SHARED borderframestart%

'Items variables
DIM SHARED levelitem(MAXLEVELITEMS) AS levelitemtype, newlevelitem AS levelitemtype, totallevelitems%, preservenewitem%

'Initialize
initrandomness
loadassembly
loaddefaultimx
initsprites
initplayer
loadnewlevel inffile1$
inittilelookup
initcolourtables
initviewports

playgame

SCREEN 0
WIDTH 80, 25
CLS
COLOR 13
PRINT "                            ۲"
COLOR 15
LOCATE 1, 15: PRINT "The RPG version ALPHA 0.04"
PRINT
COLOR 9
PRINT "Produced by:"
COLOR 7
PRINT
PRINT "Ryan Ross (a.k.a. Gamerx)"
PRINT "Milo Sedlacek (a.k.a. Gradius)"
SYSTEM
DEFINT C-D, F, W-Y

SUB addbox (px1%, py1%, px2%, py2%)
f% = borderframestart%
x1% = px1% * 16
y1% = py1% * 16
x2% = px2% * 16
y2% = py2% * 16
addstatussprite x1%, y1%, f% + 0, 6
addstatussprite x2%, y1%, f% + 1, 6
addstatussprite x1%, y2%, f% + 2, 6
addstatussprite x2%, y2%, f% + 3, 6
FOR x% = (x1% + 8) TO (x2% - 8) STEP 16
addstatussprite x%, y1%, f% + 4, 6
NEXT
FOR y% = (y1% + 8) TO (y2% - 8) STEP 16
addstatussprite x2%, y%, f% + 5, 6
NEXT
FOR x% = (x1% + 8) TO (x2% - 8) STEP 16
addstatussprite x%, y2%, f% + 6, 6
NEXT
FOR y% = (y1% + 8) TO (y2% - 8) STEP 16
addstatussprite x1%, y%, f% + 7, 6
NEXT
FOR y% = (y1% + 16) TO (y2% - 16) STEP 16
  FOR x% = (x1% + 16) TO (x2% - 16) STEP 16
    addstatussprite x%, y%, f% + 8, 6
  NEXT
NEXT
END SUB

SUB addlevelitem
i% = totallevelitems%
IF i% >= MAXLEVELITEMS THEN errorexit "out of level item space"
'memcopy VARSEG(newlevelitem.id), VARPTR(newlevelitem.id), VARSEG(levelitem(i%).id), VARPTR(levelitem(i%).id), LEN(levelitem(0))
levelitem(i%).id = newlevelitem.id
levelitem(i%).x = newlevelitem.x
levelitem(i%).y = newlevelitem.y
levelitem(i%).amount = newlevelitem.amount
IF preservenewitem% = 1 THEN
  preservenewitem% = 0
ELSE
  'memfill VARSEG(newlevelitem.id), VARPTR(newlevelitem.id), 0, LEN(levelitem(0))
  levelitem(i%).id = 0
  levelitem(i%).x = 0
  levelitem(i%).y = 0
  levelitem(i%).amount = 0
END IF
totallevelitems% = i% + 1
END SUB

SUB addnpc
i% = totalnpcs%
newnpc.x = newnpc.x * 16 + 8
newnpc.y = newnpc.y * 16 + 8
memcopy VARSEG(newnpc.id), VARPTR(newnpc.id), VARSEG(npc(i%).id), VARPTR(npc(i%).id), LEN(newnpc)
IF preservenewnpc% THEN
  preservenewnpc% = 0
ELSE
  memfill VARSEG(newnpc.id), VARPTR(newnpc.id), 0, LEN(newnpc)
END IF
totalnpcs% = i% + 1
END SUB

SUB addsprite (x%, y%, z%, frame%, imxnumber%, colourtable%, flags%, silhouette%)
i% = totallevelsprites%
IF i% >= MAXLEVELSPRITES THEN errorexit "out of sprite memory..." + CHR$(13) + "increase MAXLEVELSPRITES constant"
levelsprite(i%).x = x%
levelsprite(i%).y = y%
levelsprite(i%).z = z%
levelsprite(i%).frame = frame%
levelsprite(i%).imxnumber = imxnumber%
levelsprite(i%).colourtable = colourtable%
levelsprite(i%).flags = flags%
levelsprite(i%).silhouette = silhouette%
totallevelsprites% = i% + 1
END SUB

SUB addstatussprite (x%, y%, frame%, imxnumber%)
i% = totalstatussprites0%
IF i% >= MAXSTATUSSPRITES THEN errorexit "out of status sprites"
statussprites0(i%).x = x%
statussprites0(i%).y = y%
statussprites0(i%).z = 0
statussprites0(i%).frame = frame%
statussprites0(i%).imxnumber = imxnumber%
statussprites0(i%).colourtable = 0
statussprites0(i%).flags = 0
statussprites0(i%).silhouette = 0
totalstatussprites0% = i% + 1
END SUB

SUB addtext (pstring$, px%, py%, spacing%, colour%)

SELECT CASE colour%
  CASE 0
    imxnum% = 6
  CASE ELSE
    errorexit "colour out of range in ADDTEXT"
END SELECT

IF LEN(pstring$) = 0 THEN errorexit "addtext: passed blank string"
x% = px% * 8
y% = py% * 8 + 4
FOR i% = 1 TO LEN(pstring$)
  c% = ASC(MID$(pstring$, i%, 1))
  IF c% >= 33 AND c% <= 125 THEN addstatussprite x%, y%, (c% - 33), imxnum%
  x% = x% + spacing%
NEXT

END SUB

SUB addtextdialogue (t$)

endflag% = 0
screenx% = DIALOGUEBOXX
screeny% = DIALOGUEBOXY

wordindex% = 2
GOTO skip991a
DO
  GOSUB displayword0
skip991a:
  GOSUB grabnextword0
LOOP UNTIL t$ = "" OR endflag% = 1

grabnextword0:
t$ = ""
IF wordindex% > LEN(sample$) THEN RETURN
GOTO skip99a
DO
  t$ = t$ + char$
skip99a:
  char$ = MID$(sample$, wordindex%, 1)
  wordindex% = wordindex% + 1
LOOP UNTIL char$ = " "
t$ = t$ + " "
RETURN

displayword0:
IF (screenx% + (8 * LEN(t$))) > (DIALOGUEBOXX + 220) THEN
  screenx% = DIALOGUEBOXX
  screeny% = screeny% + 9
  IF screeny% > DIALOGUEBOXY + 30 THEN
    endflag% = 1
    RETURN
  END IF
END IF

FOR x% = 1 TO LEN(t$)
  c% = ASC(MID$(t$, x%, 1))
  IF c% >= 33 AND c% <= 125 THEN addstatussprite screenx%, screeny%, (c% - 33), 6
  screenx% = screenx% + 8
NEXT

RETURN


END SUB

SUB addviewport (px1%, py1%, px2%, py2%)
i% = totalviewports%
IF i% >= MAXVIEWPORTS THEN errorexit "Out of viewport memory..." + CHR$(13) + "increase MAXVIEWPORTS constant"
x1% = px1%
y1% = py1%
x2% = px2%
y2% = py2%
IF x1% > x2% THEN SWAP x1%, x2%
IF y1% > y2% THEN SWAP y1%, y2%
viewport(i%).x1 = x1%
viewport(i%).y1 = y1%
viewport(i%).x2 = x2%
viewport(i%).y2 = y2%
SELECT CASE i%
  CASE 0
    segment& = VARSEG(statussprites0(0).x)
    offset& = VARPTR(statussprites0(0).x)
  CASE 1
    segment& = VARSEG(statussprites1(0).x)
    offset& = VARPTR(statussprites1(0).x)
  CASE 2
    segment& = VARSEG(statussprites2(0).x)
    offset& = VARPTR(statussprites2(0).x)
  CASE 3
    segment& = VARSEG(statussprites3(0).x)
    offset& = VARPTR(statussprites3(0).x)
  CASE 4
    segment& = VARSEG(statussprites4(0).x)
    offset& = VARPTR(statussprites4(0).x)
  CASE 5
    segment& = VARSEG(statussprites5(0).x)
    offset& = VARPTR(statussprites5(0).x)
  CASE 6
    segment& = VARSEG(statussprites6(0).x)
    offset& = VARPTR(statussprites6(0).x)
  CASE 7
    segment& = VARSEG(statussprites7(0).x)
    offset& = VARPTR(statussprites7(0).x)
  CASE 8
    segment& = VARSEG(statussprites8(0).x)
    offset& = VARPTR(statussprites8(0).x)
  END SELECT
DEF SEG = VARSEG(viewport(i%).statussegment)
i& = VARPTR(viewport(i%).statussegment)
n& = segment&: l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&
DEF SEG = VARSEG(viewport(i%).statusoffset)
i& = VARPTR(viewport(i%).statusoffset)
n& = offset&: l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&
DEF SEG
totalviewports% = i% + 1
END SUB

DEFSNG D, W-Y
SUB animtiles
EXIT SUB
c = wateranimcountdown%
c = c - 1
IF c <= 0 THEN
  c = WATERANIMDELAY
  f = wateranimframe%
  f = f XOR 1
  tilelookup%(59) = 59
  IF f THEN tilelookup%(59) = 60
  wateranimframe% = f
END IF
wateranimcountdown% = c
END SUB

DEFINT D, W-Y
SUB checktalknpc

FOR i% = 0 TO totalnpcs% - 1
  difx% = player.x - npc(i%).x
  dify% = player.y - npc(i%).y
  distance1& = difx%
  distance1& = distance1& * distance1&
  distance2& = dify%
  distance2& = distance2& * distance2&
  distance& = distance1& + distance2&
  IF distance& < NPCTALKRADIUSSQUARED THEN showdialogue npc(i%).txtfile
NEXT

END SUB

SUB clearimxmem
'Erase NPC imx bank
ERASE imx7%
totalnpcimxfiles% = 0
END SUB

SUB clearnpcs
totalnpcs% = 0
END SUB

SUB clearstatussprites
totalstatussprites0% = 0
END SUB

SUB collidelevel (px%, py%, poldx%, poldy%, pflag%)
IF (px% - 8) < 0 OR (py% - 17) < 0 OR ((px% + 7) > (levelxsize% * 16)) OR ((py% + 3) > (levelysize% * 16)) THEN
  IF pflag% = 0 THEN
    px% = poldx%
    py% = poldy%
  END IF
  EXIT SUB
END IF

ox% = poldx%
oy% = poldy%

x% = ox%

FOR n% = 0 TO 1

  SELECT CASE n%
    CASE 0
      y% = py%
    CASE 1
      x% = px%
  END SELECT
  y1% = y% - PLAYERYSPACING
  y2% = y% + PLAYERYSPACING
  x1% = x% - PLAYERXSPACING
  x2% = x% + PLAYERXSPACING
 
  DEF SEG = VARSEG(atrmap%(0))
  i& = ((y1% \ 16) * levelxsize%) + (x1% \ 16) + VARPTR(atrmap%(0))
  p1% = PEEK(i&) AND 1
  i& = ((y1% \ 16) * levelxsize%) + (x2% \ 16) + VARPTR(atrmap%(0))
  p2% = PEEK(i&) AND 1
  i& = ((y2% \ 16) * levelxsize%) + (x2% \ 16) + VARPTR(atrmap%(0))
  p3% = PEEK(i&) AND 1
  i& = ((y2% \ 16) * levelxsize%) + (x1% \ 16) + VARPTR(atrmap%(0))
  p4% = PEEK(i&) AND 1
  DEF SEG
                    
 
  IF (p1% + p2% + p3% + p4%) THEN
    SELECT CASE n%
      CASE 0
        IF (y% < oy%) THEN 'moving up
          IF (p1% = 1) AND (p2% = 0) THEN
            px% = px% + 2
          ELSEIF (p1% = 0) AND (p2% = 1) THEN
            px% = px% - 2
          END IF
        ELSEIF (y% > oy%) THEN  'moving down
          IF (p4% = 1) AND (p3% = 0) THEN
            px% = px% + 2
          ELSEIF (p4% = 0) AND (p3% = 1) THEN
            px% = px% - 2
          END IF
        END IF
        y% = oy%
      CASE 1
        x% = ox%
    END SELECT
  END IF


NEXT

skip1:
px% = x%
py% = y%
poldx% = ox%
poldy% = oy%

END SUB

SUB collidenpc

px1% = player.x - PLAYERXSPACING
py1% = player.y - PLAYERYSPACING
px2% = player.x + PLAYERXSPACING
py2% = player.y + PLAYERYSPACING

FOR i% = 0 TO totalnpcs% - 1
  npcx1% = npc(i%).x - NPCSPACINGX
  npcy1% = npc(i%).y - NPCSPACINGY
  npcx2% = npc(i%).x + NPCSPACINGX
  npcy2% = npc(i%).y + NPCSPACINGY

  'bounding box test
  IF (px2% > npcx1%) AND (px1% < npcx2%) AND (py2% > npcy1%) AND (py1% < npcy2%) THEN
    player.x = player.oldx
    player.y = player.oldy
    npc(i%).x = npc(i%).oldx
    npc(i%).y = npc(i%).oldy
  END IF

NEXT

END SUB

SUB dellevelitem (pindex%)
i% = totallevelitems% - 1
IF i% < 0 THEN errorexit "Tried to delete nonexistent object"
memcopy VARSEG(levelitem(i%).id), VARPTR(levelitem(i%).id), VARSEG(levelitem(pindex%).id), VARPTR(levelitem(pindex%).id), LEN(levelitem(0))
totallevelitems% = i%
END SUB

DEFSNG C-D, F, W
SUB docamera
x = camerax%
y = cameray%
x = player.x - 160
y = player.y - 100
minlimit x, 0
minlimit y, 0
maxlimit x, (levelxsize% * 16) - 320
maxlimit y, (levelysize% * 16) - 200
camerax% = x
cameray% = y
END SUB

DEFINT C-D, F, W
SUB DOCitems

'type, x, y, (data 0), (data 1), ... , (data n)
'
'ITEMS:
'------
'
'type:          description:          data:
'
'0              cure 1                amount
'
'1              cure 2                amount
'
'2              cure 3                amount
'
'3              tent                  amount
'
'4              gp                    amount
'
'5              elixir                amount
'
'6              ether 1               amount
'
'7              ether 2               amount

END SUB

SUB DOCmisc

'imx bank usage:
'
'bank       usage
'----       -----
'
'0          player sprite
'1-5        level sprites
'6          npcs
'7          status sprites

END SUB

SUB DOCnpc

'NPC DOCUMENTATION
'
'tag:      description:         data bytes:
'----      ------------         -----------
'
'0         walking villager     x%, y%, imxfile$, txtfile$
'

END SUB

SUB docontrols
oldspacebar% = spacebar%
spacebar% = kb(57)
END SUB

SUB DOCtriggers
'
'id    description           fields
'
'0      door - way link       int0 = door x
'                             int1 = door y
'                             int2 = destination x
'                             int3 = destination y
'                             string0 = teleport inf file
'
'1      1-way teleport link   int0 = trigger x
'                             int1 = trigger y
'                             int2 = destination x
'                             int3 = destination y
'                             string0 = teleport inf file
'
'2      walk off map link     int0 = destination x
'                             int1 = destination y
'                             string0 = teleport inf file
'
'3      head disappear tile   int0 = tile number
'
'4      tile animation (2 frame)    int0 = old tile
'                                   int1 = new tile
'                                   int2 = original delay
'                                   int3 = anim counter
'                                   int4 = current frame (0 or 1)
'
END SUB

SUB dofadeinout

dx% = 6
dy% = 4
IF gamemode% = 2 THEN
  dx% = -dx%
  dy% = -dy%
END IF

viewport(0).x1 = viewport(0).x1 + dx%
viewport(0).y1 = viewport(0).y1 + dy%
viewport(0).x2 = viewport(0).x2 - dx%
viewport(0).y2 = viewport(0).y2 - dy%

IF gamemode% = 1 THEN
  LINE (viewport(0).x1 - 1, viewport(0).y1 - dy%)-(viewport(0).x1 - dx%, viewport(0).y2 + dy%), 0, BF
  LINE (viewport(0).x1 - dx%, viewport(0).y1 - dy%)-(viewport(0).x2 + dx%, viewport(0).y1 - 1), 0, BF
  LINE (viewport(0).x2 + 1, viewport(0).y1 - dy%)-(viewport(0).x2 + dx%, viewport(0).y2 + dy%), 0, BF
  LINE (viewport(0).x1 - dx%, viewport(0).y2 + dy%)-(viewport(0).x2 + dx%, viewport(0).y2 + 1), 0, BF
END IF

f% = 0
SELECT CASE gamemode%
  CASE 1
    IF (viewport(0).x1 >= viewport(0).x2) OR (viewport(0).y1 >= viewport(0).y2) THEN f% = 1
  CASE 2
    IF (viewport(0).x1 <= 0) OR (viewport(0).y1 <= 0) OR (viewport(0).x2 >= 319) OR (viewport(0).y2 >= 199) THEN f% = 1
END SELECT

IF f% THEN
  SELECT CASE gamemode%
    CASE 1
      gamemode% = 2
      viewport(0).x1 = 160
      viewport(0).y1 = 100
      viewport(0).x2 = 160
      viewport(0).y2 = 100
      CLS
    CASE 2
      gamemode% = 0
      viewport(0).x1 = 0
      viewport(0).y1 = 0
      viewport(0).x2 = 319
      viewport(0).y2 = 199
  END SELECT
END IF

END SUB

SUB donpc

'For every npc
FOR i% = 0 TO totalnpcs% - 1

  'Pick new direction if neccessary
  c% = npc(i%).motionchangecountdown
  c% = c% - 1
  IF c% <= 0 THEN
    c% = 16
   
    'Pick a direction for npc so it doesn't run into a wall
    DO

      'Pick direction for npc
      D% = INT(RND * 3.999)

      'See if direction runs into a solid tile
      x% = npc(i%).x
      y% = npc(i%).y
     
      'Initialize deltas
      dx% = 0
      dy% = 0

      'Move npc to new location
      SELECT CASE D%
        CASE 0   'up
          dy% = -16
        CASE 1   'right
          dx% = 16
        CASE 2   'down
          dy% = 16
        CASE 3   'left
          dx% = -16
      CASE ELSE
        errorexit "walk direction out of range in DONPC sub"
      END SELECT
      x% = x% + dx%
      y% = y% + dy%
     
      'Save npc's co-ordinates
      ox% = x%
      oy% = y%
     
      'Carry out collision test
      collidelevel x%, y%, npc(i%).oldx, npc(i%).oldy, 0

      'If there was no collisionn then exit loop
      IF (x% = ox%) AND (y% = oy%) THEN EXIT DO
      
    LOOP

    'Copy temp to variables
    npc(i%).direction = D%
 
  END IF
  npc(i%).motionchangecountdown = c%

  'Determine npc frame
  framestart% = 0
  flip% = 0

  'Move npc
  SELECT CASE npc(i%).direction
    CASE 0      'up
      npc(i%).y = npc(i%).y - 1
      framestart% = 3
    CASE 1      'right
      npc(i%).x = npc(i%).x + 1
      flip% = 1
    CASE 2      'down
      npc(i%).y = npc(i%).y + 1
      framestart% = 6
    CASE 3      'left
      npc(i%).x = npc(i%).x - 1
  END SELECT
 
  'Switch walk frames
  walkingcontrol npc(i%).walkframe, npc(i%).walkanimcountdown, 4
 
  'Update sprite structures
  n% = npc(i%).spritenumber
  levelsprite(n%).x = npc(i%).x
  levelsprite(n%).y = npc(i%).y
  levelsprite(n%).frame = framestart% + npc(i%).startwalkframe + getanimoffset%(npc(i%).walkframe)
  levelsprite(n%).flags = flip% + flip%

NEXT
 
 
 
 
'  id AS INTEGER
'  x AS INTEGER
'  y AS INTEGER
'  z AS INTEGER
'  flip AS INTEGER
'  frame AS INTEGER
'  imxnumber AS INTEGER
'  direction AS INTEGER            '0 = up, 1 = right, 2 = down, 3 = left
'  walkframe AS INTEGER
'  walkanimcountdown AS INTEGER
'  oldx AS INTEGER
'  oldy AS INTEGER
'  startwalkframe AS INTEGER
'  motionchangecountdown AS INTEGER
'  motionchangedelay AS INTEGER
'  txtfile AS STRING * 12


END SUB

SUB doplayer

'structures into temp
x = player.x
y = player.y

'keyboard responder
dx% = 0
dy% = 0
IF kb(72) THEN dy% = -2
IF kb(77) THEN dx% = 2
IF kb(80) THEN dy% = dy% + 2
IF kb(75) THEN dx% = dx% - 2

'test code
dx% = dx% * (1 + kb(29))
dy% = dy% * (1 + kb(29))
'end -> test code

'motion control
x = x + dx% * 2
y = y + dy% * 2

'direction change control
D = player.direction
IF dx% < 0 AND dy% = 0 THEN D = 3
IF dx% > 0 AND dy% = 0 THEN D = 1
IF dy% < 0 AND dx% = 0 THEN D = 0
IF dy% > 0 AND dx% = 0 THEN D = 2
player.direction = D

'walking control
IF dx% <> 0 OR dy% <> 0 THEN walkingcontrol player.walkframe, player.walkanimcountdown, PLAYERWALKANIMDELAY
o% = getanimoffset%(player.walkframe)

'select fame using direction & anim offset
pf% = 0
SELECT CASE D
  CASE 0
    f% = 3 + o%
  CASE 1
    f% = o%
    pf% = 1
  CASE 2
    f% = 6 + o%
  CASE 3
    f% = o%
END SELECT
player.flip = pf%
player.frame = f%

'temp into structures
player.x = x
player.y = y

'Collide player with map
collidelevel player.x, player.y, player.oldx, player.oldy, 1

'Calculate player's location in terms of tiles
player.tilex = player.x \ 16
player.tiley = player.y \ 16

'Check if player wants to talk
IF (spacebar% = 1) AND (oldspacebar% = 0) THEN
 
  checktalknpc
  'searchlevelforitem
END IF

END SUB

SUB dotriggers
tx% = player.x \ 16
ty% = player.y \ 16
otx% = player.oldx \ 16
oty% = player.oldy \ 16

DEF SEG = VARSEG(level%(0))
tile% = PEEK(ty% * levelxsize% + tx% + VARPTR(level%(0)))
DEF SEG

'test code
IF trigger(6).int0 = 10 THEN

ELSE
  IF currentinffilename$ = "c:\weez\rpg\map\worldmap.inf" THEN
 
  END IF
END IF
'end -> test code


'Run through all triggers
FOR n% = 0 TO totaltriggers% - 1
 
  'General code - see if trigger was stepped on
  f% = 0
  IF ((tx% = trigger(n%).int0) AND (ty% = trigger(n%).int1)) THEN
    IF ((otx% <> trigger(n%).int0) OR (oty% <> trigger(n%).int1)) THEN f% = 1
  END IF
  triggersteppedon% = f%

  'Specific trigger code
  SELECT CASE trigger(n%).id
    CASE 0
      IF f% THEN
        setlevelelement tx%, ty% - 1, 103
        setlevelelement tx%, ty%, 119
        teleport trigger(n%).string0, trigger(n%).int2, trigger(n%).int3, 1, n%
      END IF
    CASE 1
      IF f% THEN
        teleport trigger(n%).string0, trigger(n%).int2, trigger(n%).int3, 0, n%
      END IF
    CASE 2
      IF (player.x < 8) OR (player.y < 8) OR ((player.x + 8) > levelxsize% * 16) OR ((player.y + 4) > levelysize% * 16 + 24) THEN
        teleport (trigger(n%).string0), (trigger(n%).int0), (trigger(n%).int1), 0, n%
      END IF
    CASE 3
      IF (tile% = trigger(n%).int0) THEN
        levelsprite(0).frame = levelsprite(0).frame + 9
        levelsprite(0).y = levelsprite(0).y - 7
      END IF
    CASE 4
      IF gamemode% = 0 THEN
        trigger(n%).int3 = trigger(n%).int3 - 1
        IF (trigger(n%).int3 < 0) THEN
          trigger(n%).int3 = trigger(n%).int2
          trigger(n%).int4 = trigger(n%).int4 XOR 1
          SELECT CASE trigger(n%).int4
            CASE 0
              t% = trigger(n%).int0
            CASE 1
              t% = trigger(n%).int1
            CASE ELSE

          END SELECT
          tilelookup%(trigger(n%).int0) = t%
        END IF
      END IF
  END SELECT
NEXT

END SUB

SUB drawscreen
engine%(132) = levelxsize%
engine%(135) = totalviewports%
engine%(138) = totallevelsprites%
viewport(0).camerax = camerax% + viewport(0).x1
viewport(0).cameray = cameray% + viewport(0).y1
viewport(0).totalstatus = totalstatussprites0%
viewport(1).totalstatus = totalstatussprites1%
viewport(2).totalstatus = totalstatussprites2%
viewport(3).totalstatus = totalstatussprites3%
viewport(4).totalstatus = totalstatussprites4%
viewport(5).totalstatus = totalstatussprites5%
viewport(6).totalstatus = totalstatussprites6%
viewport(7).totalstatus = totalstatussprites7%

WAIT &H3DA, 8
WAIT &H3DA, 8, 8

DEF SEG = VARSEG(engine%(0))
CALL ABSOLUTE(0)
DEF SEG
END SUB

SUB eraselevelitems
totallevelitems% = 0
END SUB

SUB eraselevelsprites
totallevelsprites% = 1
END SUB

SUB errorexit (pstring$)
offkb
LOCATE 1, 1
COLOR 15
OUT &H3C8, 15
OUT &H3C9, 63
OUT &H3C9, 63
OUT &H3C9, 63
OUT &H3C8, 0
OUT &H3C9, 0
OUT &H3C9, 0
OUT &H3C9, 0
PRINT pstring$
END
END SUB

SUB fadeouttransition

'Do not fade if the game is loading a level for the first time
IF LEN(currentinffilename$) = 0 THEN EXIT SUB

'Do fadeout transition
gamemode% = 1
DO
  dofadeinout
  drawscreen
LOOP UNTIL gamemode% = 2

'Clear the screen
CLS

END SUB

FUNCTION getanimoffset% (f%)

'Cycle -> Ping pong animation conversion
SELECT CASE f%
  CASE 0
    r% = 0
  CASE 1
    r% = 1
  CASE 2
    r% = 2
  CASE 3
    r% = 1
END SELECT

'Return value
getanimoffset% = r%

END FUNCTION

SUB initcolourtables
FOR i% = 0 TO 255
  colourtable0%(i%) = i%
  colourtable1%(i%) = ((i% AND 15) \ 2) + 16
  colourtable2%(i%) = ((i% AND 15) \ 2) + 24
NEXT
END SUB

SUB initmaskenable
DEF SEG = VARSEG(checkmaskrtn%(0))
CALL ABSOLUTE(VARSEG(maskenable%(0)), VARPTR(maskenable%(0)), VARSEG(engine%(0)), VARPTR(engine%(0)), 255, 0)
DEF SEG
END SUB

SUB initplayer
newplayerx% = 16 + 8
newplayery% = 70 + 58
player.direction = 1
player.walkframe = 1
END SUB

SUB initrandomness
RANDOMIZE TIMER
END SUB

SUB initsprites
'Initialize player sprite
addsprite player.x, player.y, player.z, player.frame, 0, 0, 0, 0
END SUB

SUB inittilelookup
FOR i% = 0 TO 255
  tilelookup%(i%) = i%
NEXT
END SUB

SUB initviewports
addviewport 0, 0, 319, 199
END SUB

SUB loadassembly

'Load graphics engine
DEF SEG = VARSEG(engine%(0))
BLOAD asmfile1$, 0
i& = 256
n& = VARSEG(tiles%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(tiles%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(level%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(level%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = i& + 2
n& = VARSEG(viewport(0).x1): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(viewport(0).x1): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = i& + 2
n& = VARSEG(levelsprite(0).x): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(levelsprite(0).x): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = i& + 2
n& = VARSEG(tilelookup%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(tilelookup%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(colourtable0%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(colourtable0%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(colourtable1%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(colourtable1%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(colourtable2%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(colourtable2%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(maskenable%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(maskenable%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = i& + 4
n& = VARSEG(spritestream(0).x): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(spritestream(0).x): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = i& + 2
n& = VARSEG(doublebuffer%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(doublebuffer%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
i& = 320
n& = VARSEG(imx0%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx0%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx1%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx1%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx2%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx2%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx3%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx3%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx4%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx4%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx5%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx5%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx6%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx6%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARSEG(imx7%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(imx7%(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
DEF SEG

'Load keyboard interrupt
DEF SEG = VARSEG(kbcontrol%(0))
BLOAD asmfile2$, 0
i& = 16
n& = VARSEG(kb(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(kb(0)): l& = n& AND 255: h& = (n& AND &HFF00) \ 256: POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
DEF SEG

'Mask checking/enable routine
DEF SEG = VARSEG(checkmaskrtn%(0))
BLOAD asmfile3$, 0
DEF SEG

'Load memory fill routine
DEF SEG = VARSEG(memfillrtn%(0))
BLOAD asmfile4$, VARPTR(memfillrtn%(0))
DEF SEG

'Load memory move routine
DEF SEG = VARSEG(movememrtn%(0))
BLOAD asmfile5$, VARPTR(movememrtn%(0))
DEF SEG

END SUB

SUB loadatrmap
IF atrfile1$ <> "" THEN
  DEF SEG = VARSEG(atrmap%(0))
  BLOAD atrfile1$, VARPTR(atrmap%(0))
  DEF SEG
ELSE
  ERASE atrmap%
END IF
END SUB

SUB loaddefaultimx
a% = mergeloadimx%(fontimxfile$, 6)
borderframestart% = mergeloadimx%(borderimxfile$, 6)
END SUB

SUB loadimx
FOR n% = 0 TO 7
  IF imxfile$(n%) <> "" THEN
    SELECT CASE n%
      CASE 0
        s& = VARSEG(imx0%(0))
        o& = VARPTR(imx0%(0))
      CASE 1
        s& = VARSEG(imx1%(0))
        o& = VARPTR(imx1%(0))
      CASE 2
        s& = VARSEG(imx2%(0))
        o& = VARPTR(imx2%(0))
      CASE 3
        s& = VARSEG(imx3%(0))
        o& = VARPTR(imx3%(0))
      CASE 4
        s& = VARSEG(imx4%(0))
        o& = VARPTR(imx4%(0))
      CASE 5
        s& = VARSEG(imx5%(0))
        o& = VARPTR(imx5%(0))
      CASE 6
        s& = VARSEG(imx6%(0))
        o& = VARPTR(imx6%(0))
      CASE 7
        s& = VARSEG(imx7%(0))
        o& = VARPTR(imx7%(0))
    END SELECT
    DEF SEG = s&
    BLOAD imxfile$(n%), o&
    DEF SEG
  END IF
NEXT

END SUB

SUB loadlevel
DEF SEG = VARSEG(level%(0))
BLOAD levfile1$, VARPTR(level%(0))
DEF SEG
END SUB

SUB loadmasks
IF mskfile1$ <> "" THEN
  DEF SEG = VARSEG(engine%(0))
  BLOAD mskfile1$, &H700
  DEF SEG
  initmaskenable
ELSE
  FOR n% = 0 TO 255
    maskenable%(n%) = 0
  NEXT
END IF
END SUB

SUB loadnewlevel (filename$)

'Do screen transition effect
fadeouttransition

'Erase all sprites except for main character
eraselevelsprites

'Erase all items in level
eraselevelitems

'Save name of information file
currentinffilename$ = filename$

OPEN currentinffilename$ FOR INPUT AS #1
INPUT #1, newlevelxsize%, newlevelysize%, levfile1$, chrfile1$, palfile1$, mskfile1$, atrfile1$
LINE INPUT #1, t$
i% = 1
GOTO skip0
DO
  IF i% = 6 THEN errorexit "maximum of 5 imx files per inf file"
  imxfile$(i%) = t$
  i% = i% + 1
skip0:
  INPUT #1, t$
LOOP UNTIL t$ = "end"

'Read "** triggers **" banner
LINE INPUT #1, t$

'Read triggers
i% = 0
DO UNTIL EOF(1)
  INPUT #1, tag%
  SELECT CASE tag%
    CASE -1
      EXIT DO
    CASE 0            'door
      INPUT #1, trigger(i%).int0, trigger(i%).int1, t$, trigger(i%).int2, trigger(i%).int3
      trigger(i%).string0 = t$
    CASE 1            '1 way link
      INPUT #1, trigger(i%).int0, trigger(i%).int1, t$, trigger(i%).int2, trigger(i%).int3
      trigger(i%).string0 = t$
    CASE 2            'walk off map link
      INPUT #1, trigger(i%).int0, trigger(i%).int1, t$
      trigger(i%).string0 = t$
    CASE 3            'head disappear tile
      INPUT #1, trigger(i%).int0
    CASE 4
      INPUT #1, trigger(i%).int0, trigger(i%).int1, trigger(i%).int2
      trigger(i%).int3 = 0
      trigger(i%).int4 = 0
  END SELECT
  trigger(i%).id = tag%
  i% = i% + 1
  IF i% >= MAXTRIGGERS THEN errorexit "out of trigger space"
LOOP
totaltriggers% = i%

'Read "** npc **" banner
LINE INPUT #1, t$

'Clear npc imx memory
clearimxmem
clearnpcs

'Read npc data
i% = 0
DO UNTIL EOF(1)
  INPUT #1, tag%
  SELECT CASE tag%
    CASE -1
      EXIT DO
    CASE 0            'walking villager
      INPUT #1, newnpc.x, newnpc.y, f1$, f2$
      newnpc.startwalkframe = mergeloadimx%(f1$, 7)
      newnpc.txtfile = f2$
      addnpc
      addsprite npc(totalnpcs% - 1).x, npc(totalnpcs% - 1).y, 0, 0, 7, 0, 0, 0
      npc(totalnpcs% - 1).spritenumber = totallevelsprites% - 1
  END SELECT
  npc(i%).id = tag%
  i% = i% + 1
  IF i% >= MAXNPCS THEN errorexit "out of npc space"
LOOP

'Read optional "** items **" banner
LINE INPUT #1, t$
IF t$ = "** items **" THEN
  DO UNTIL EOF(1)
    'test code
    EXIT DO
    'end -> test code
    INPUT #1, tag%
    IF tag% = -1 THEN EXIT DO
    newlevelitem.id = tag%
    SELECT CASE tag%
      CASE 0 TO 7
        INPUT #1, newlevelitem.x, newlevelitem.y, newlevelitem.amount
        addlevelitem
    END SELECT
  LOOP
END IF

'Close inf file
CLOSE #1

'Always load main character imx
imxfile$(0) = defaultimxfile$

'Load everything
loadstuff

END SUB

SUB loadpalette
DEF SEG = VARSEG(pal%(0))
i& = VARPTR(pal%(0))
BLOAD palfile1$, i&
FOR c% = 0 TO 255
  OUT &H3C8, c%
  OUT &H3C9, PEEK(i&)
  OUT &H3C9, PEEK(i& + 1)
  OUT &H3C9, PEEK(i& + 2)
  i& = i& + 3
NEXT
DEF SEG
END SUB

SUB loadstuff

'Copy new to current variables
levelxsize% = newlevelxsize%
levelysize% = newlevelysize%
player.x = newplayerx%
player.y = newplayery%
player.oldx = player.x
player.oldy = player.y

'Load files
loadpalette
loadtiles
loadlevel
loadmasks
loadimx
loadatrmap
inittilelookup

END SUB

SUB loadtiles
DEF SEG = VARSEG(tiles%(0))
BLOAD chrfile1$, VARPTR(tiles%(0))
DEF SEG
END SUB

SUB maxlimit (a%, b%)
IF a% > b% THEN a% = b%
END SUB

SUB memcopy (psourcesegment&, psourceoffset&, pdestinationsegment&, pdestinationoffset&, plength&)
IF plength& = 0 THEN EXIT SUB
DEF SEG = VARSEG(movememrtn%(0))
CALL ABSOLUTE(psourcesegment&, psourceoffset&, pdestinationsegment&, pdestinationoffset&, plength&, VARPTR(movememrtn%(0)))
DEF SEG
END SUB

SUB memfill (psegment&, poffset&, pvalue%, plength&)
DEF SEG = VARSEG(memfillrtn%(0))
CALL ABSOLUTE(psegment&, poffset&, pvalue%, plength&, VARPTR(memfillrtn%(0)))
DEF SEG
END SUB

FUNCTION mergeloadimx% (filename$, imxbank%)

'Select proper imx load to merge load in
SELECT CASE imxbank%
  CASE 0
    s& = VARSEG(imx0%(0))
    o& = VARPTR(imx0%(0))
    wordsize& = IMXBANK0WORDSIZE
  CASE 1
    s& = VARSEG(imx1%(0))
    o& = VARPTR(imx1%(0))
    wordsize& = IMXBANK1WORDSIZE
  CASE 2
    s& = VARSEG(imx2%(0))
    o& = VARPTR(imx2%(0))
    wordsize& = IMXBANK2WORDSIZE
  CASE 3
    s& = VARSEG(imx3%(0))
    o& = VARPTR(imx3%(0))
    wordsize& = IMXBANK3WORDSIZE
  CASE 4
    s& = VARSEG(imx4%(0))
    o& = VARPTR(imx4%(0))
    wordsize& = IMXBANK4WORDSIZE
  CASE 5
    s& = VARSEG(imx5%(0))
    o& = VARPTR(imx5%(0))
    wordsize& = IMXBANK5WORDSIZE
  CASE 6
    s& = VARSEG(imx6%(0))
    o& = VARPTR(imx6%(0))
    wordsize& = IMXBANK6WORDSIZE
  CASE 7
    s& = VARSEG(imx7%(0))
    o& = VARPTR(imx7%(0))
    wordsize& = IMXBANK7WORDSIZE
END SELECT

'See if imx file is already loaded in bank
FOR i% = 0 TO totalnpcimxfiles% - 1
  'If imx is in bank then return frame start number and exit
  IF filename$ = npcimxfile$(i%) THEN
    mergeloadimx% = npcimxstartframe%(i%)
    EXIT FUNCTION
  END IF
NEXT

'Read total frames in imx bank
DEF SEG = s&
totalframes% = PEEK(o&) + PEEK(o& + 1) * 256
DEF SEG

'Return value to caller stating where imx frames start in bank
mergeloadimx% = totalframes%

'Open imx file
  'Error test
OPEN filename$ FOR INPUT AS #2
CLOSE #2
  'Open file
OPEN filename$ FOR BINARY ACCESS READ AS #2

'Read total frames in new imx file
GET #2, 7 + 1, totalframesinfile%

'Determine if imx file will fit into imx bank
  'Determine current memory usage in imx bank
    'Account for imx header and lookup table
bytes& = 16 + totalframes% * 2
FOR i% = 0 TO totalframes% - 1
 
  'grab index to imx array element containing image
  DEF SEG = s&
  v% = PEEK(o& + 16 + i% * 2) + PEEK(o& + 17 + i% * 2) * 256
  element% = v%
  DEF SEG
 
  'determine x size of image
  DEF SEG = s&
  a& = element%
  a& = a& * 2
  a& = a& + o&
  v% = PEEK(a&) + PEEK(a& + 1)
  xsize% = v% \ 8
  DEF SEG

  'determine y size of image
  DEF SEG = s&
  a& = a& + 2
  v% = PEEK(a&) + PEEK(a& + 1)
  ysize% = v%
  DEF SEG
 
  'determine frame memory usage
  bytes& = bytes& + 4 + xsize% * ysize%

  'word alignment
  IF (bytes& AND 1) > 0 THEN bytes& = bytes& + 1
NEXT

  'Determine number of bytes in new imx file
    'Subtract 16 bytes for imx header
filebytes& = LOF(2) - 16

  'Really determine if imx file will fit into imx bank
tmax& = wordsize&
tmax& = tmax& * 2
IF (bytes& + filebytes&) > tmax& THEN errorexit "not enough memory to load imx"

'Insert blank frames into imx bank
  'Move frames after lookup
i& = o&
t% = totalframesinfile% * 2
sourceindex& = i& + 16 + totalframes% * 2
destinationindex& = sourceindex& + t%
bytesize& = bytes& - sourceindex&

memcopy s&, sourceindex&, s&, destinationindex&, bytesize&
  'Fill new lookup entries with blank values
memfill s&, sourceindex&, 0, CLNG(t%)
  'Update lookup table to reflect memory move
DEF SEG = s&
i& = o& + 16
FOR i% = 0 TO totalframes% - 1
  value& = PEEK(i& + 1)
  value& = value& * 256
  value& = value& + PEEK(i&)
  value& = value& + totalframesinfile%
  POKE i&, value& AND 255
  POKE i& + 1, value& \ 256
  i& = i& + 2
NEXT
DEF SEG

'Load frames into imx bank
DEF SEG = s&
writeindex& = destinationindex& + bytesize&
FOR frame% = 0 TO totalframesinfile% - 1

  'Grab file index to frame from lookup
  GET #2, 8 + 16 + (frame% * 2), t%
  readindex& = t%
  readindex& = 8 + readindex& * 2

  'Update imx lookup table
  DEF SEG = s&
  a& = 8 + totalframes% + frame%
  a& = a& * 2
  a& = a& + o&
  v& = (writeindex& - o&) \ 2
  POKE a&, v& AND 255
  POKE a& + 1, v& \ 256
  DEF SEG

  'Load image into frame bank
    'Determine x size of image
  GET #2, readindex&, xsize%
    'Adjust for bits / line xsize definition
  xsize% = xsize% \ 8

    'Determine y size of image
  GET #2, readindex& + 2, ysize%

    'Determine number of bytes to transfer
  bytestotransfer& = xsize% * ysize% + 4
 
  numblocks& = bytestotransfer& \ 256
  numbytes& = bytestotransfer& AND 255
 
  FOR n& = 0 TO numblocks& - 1
    GET #2, readindex&, block
    memcopy VARSEG(block), VARPTR(block), s&, writeindex&, 256
    DEF SEG = s&
    readindex& = readindex& + 256
    writeindex& = writeindex& + 256
  NEXT
 
  DEF SEG = s&
  FOR n& = 0 TO numbytes& - 1
    GET #2, readindex&, char
    POKE writeindex&, ASC(char)
    readindex& = readindex& + 1
    writeindex& = writeindex& + 1
  NEXT

  'imx word alignment adjustment
  IF (writeindex& AND 1) > 0 THEN writeindex& = writeindex& + 1

NEXT
DEF SEG

'Update total frames in imx
DEF SEG = s&
v& = PEEK(o&) + PEEK(o& + 1) * 256
v& = v& + totalframesinfile%
POKE o&, v& AND 255
POKE o& + 1, v& \ 256
DEF SEG

'Close imx file
CLOSE #2

'Store imx file information in imx bank
i% = totalnpcimxfiles%
npcimxfile$(i%) = filename$
npcimxstartframe%(i%) = totalframes%
totalnpcimxfiles% = i% + 1

END FUNCTION

SUB minlimit (a%, b%)
IF a% < b% THEN a% = b%
END SUB

FUNCTION num$ (p%)
num$ = MID$(STR$(p%), 2, LEN(STR$(p%)) - 1)
END FUNCTION

SUB offkb
IF keyboardonflag% = 0 THEN EXIT SUB
keyboardonflag% = 0
DEF SEG = VARSEG(kbcontrol%(0))
CALL ABSOLUTE(3)
DEF SEG
END SUB

SUB onkb
IF keyboardonflag% THEN EXIT SUB
keyboardonflag% = 1
DEF SEG = VARSEG(kbcontrol%(0))
CALL ABSOLUTE(0)
DEF SEG
END SUB

SUB playgame
onkb

DO
  docontrols
  animtiles
  SELECT CASE gamemode%
    CASE 0
      doplayer
      updatespritestruct
      dotriggers
      donpc
      collidenpc
    CASE 1, 2
      dofadeinout
      updatespritestruct
  END SELECT
  'test code
  showposition
  'end -> test code
  docamera
  drawscreen
  saveold
LOOP UNTIL kb(1)

offkb
END SUB

SUB saveold
player.oldx = player.x
player.oldy = player.y

'Save old npc locations
FOR i% = 0 TO totalnpcs% - 1
  npc(i%).oldx = npc(i%).x
  npc(i%).oldy = npc(i%).y
NEXT

END SUB

'Check if there's an item a tile away from the player in the direction they
'are facing.
'
SUB searchlevelforitem

'Calculate locals so that level is searched in appropriate spot
x% = player.tilex
y% = player.tiley
SELECT CASE player.direction
  CASE 0        'up
    y% = y% - 1
  CASE 1        'right
    x% = x% + 1
  CASE 2        'down
    y% = y% + 1
  CASE 3        'left
    x% = x% - 1
END SELECT

'Run through every item in the level
FOR i% = 0 TO totallevelitems% - 1
  
  'See if item's location matches search location
  IF (x% = levelitem(i%).x) AND (y% = levelitem(i%).y) THEN
    showmessage "You have found an item!"
  END IF
  
NEXT

END SUB

SUB setlevelelement (x%, y%, value%)
DEF SEG = VARSEG(level%(0))
i& = y% * levelxsize% + x% + VARPTR(level%(0))
POKE i&, value%
DEF SEG
END SUB

SUB showdialogue (filename$)
   
'Open dialogue file
OPEN filename$ FOR INPUT AS #1

'Draw box
addbox 3, 1, 16, 4

'Add text
GOSUB addboxtext

'Update screen
drawscreen

'Wait for space press
DO
  docontrols
  IF (spacebar% = 1) AND (oldspacebar% = 0) THEN EXIT DO
LOOP UNTIL kb(1)

'Erase all status sprites
clearstatussprites

'Close file
CLOSE #1
EXIT SUB

addboxtext:
endflag% = 0
screenx% = DIALOGUEBOXX
screeny% = DIALOGUEBOXY
DO
  LINE INPUT #1, sample$
 
  wordindex% = 2
  GOTO skip991
  DO
    GOSUB displayword
skip991:
    GOSUB grabnextword
  LOOP UNTIL t$ = "" OR endflag% = 1

LOOP UNTIL EOF(1) OR endflag% = 1

RETURN

grabnextword:
t$ = ""
IF wordindex% > LEN(sample$) THEN RETURN
GOTO skip99
DO
  t$ = t$ + char$
skip99:
  char$ = MID$(sample$, wordindex%, 1)
  wordindex% = wordindex% + 1
LOOP UNTIL char$ = " "
t$ = t$ + " "
RETURN

displayword:
IF (screenx% + (8 * LEN(t$))) > (DIALOGUEBOXX + 220) THEN
  screenx% = DIALOGUEBOXX
  screeny% = screeny% + 9
  IF screeny% > DIALOGUEBOXY + 30 THEN
    endflag% = 1
    RETURN
  END IF
END IF

FOR x% = 1 TO LEN(t$)
  c% = ASC(MID$(t$, x%, 1))
  IF c% >= 33 AND c% <= 125 THEN addstatussprite screenx%, screeny%, (c% - 33), 6
  screenx% = screenx% + 8
NEXT

RETURN

END SUB

SUB showmessage (message$)
  
'Draw box
addbox 3, 1, 16, 4

'Add text
addtextdialogue message$

'Update screen
drawscreen

'Wait for space press
DO
  docontrols
  IF (spacebar% = 1) AND (oldspacebar% = 0) THEN EXIT DO
LOOP UNTIL kb(1)

'test code
FOR n% = 0 TO 10
WAIT &H3DA, 8
WAIT &H3DA, 8, 8
NEXT
'end -> test code

'Erase all status sprites
clearstatussprites

END SUB

SUB showposition
IF kb(56) THEN
  LOCATE 1, 1
  PRINT player.x \ 16
  PRINT player.y \ 16
  FOR n% = 0 TO 10
    t1 = TIMER
    DO WHILE t1 = TIMER
    LOOP
  NEXT
END IF
END SUB

SUB teleport (filename$, x%, y%, linkflag%, index%)

'Handle 2-way links
IF linkflag% THEN
  destx% = player.x \ 16
  desty% = player.y \ 16
  destfilename$ = currentinffilename$
END IF

'Load new level and change player's position
newplayerx% = x% * 16 + 8
newplayery% = y% * 16 + 15
loadnewlevel filename$

'If teleported using 2-way link add it
IF linkflag% THEN
  i% = totaltriggers%
  trigger(i%).id = 1
  trigger(i%).int0 = x%
  trigger(i%).int1 = y%
  trigger(i%).int2 = destx%
  trigger(i%).int3 = desty%
  trigger(i%).string0 = destfilename$
  totaltriggers% = i% + 1
END IF

IF totaltriggers% >= index% THEN
  filename$ = trigger(index%).string0
  x% = trigger(index%).int2
  y% = trigger(index%).int3
END IF

END SUB

SUB updatespritestruct
'player
levelsprite(0).x = player.x
levelsprite(0).y = player.y
levelsprite(0).frame = player.frame
levelsprite(0).flags = player.flip * 2
END SUB

SUB walkingcontrol (f%, c%, D%)

c% = c% - 1
IF c% <= 0 THEN
  c% = D%
  f% = f% + 1
  IF f% > 3 THEN f% = 0
END IF

END SUB

